	.ORIG	x3000
	LDI	R1, LOCIN	;R1 = in
	ADD	R6, R6, 0	;stack pointer
	LEA	R6, SAVER1
	LEA	R7, #1
	BRnzp	FIB
	STI	R0, LOCOUT	;R0 = out
	HALT
	
LOCIN	.FILL	x3100
LOCOUT	.FILL	x3101

FIB	STR	R2, R6, #0	;saveR2
	ADD	R6, R6, #1	;stack pointer++
	STR	R1, R6, #0	;saveR1
	ADD	R6, R6, #1	;stack pointer++
	STR	R7, R6, #0	;saveR7
	ADD	R6, R6, #1	;stack pointer++

	ADD	R1, R1, #0
	BRz	isZERO		;if n==0
	ADD	R1, R1, #-1
	BRz	isONE		;if n==1

	LEA	R7, #1
	BRnzp	FIB		;fib(n-1)
	AND	R2, R2, 0
	ADD	R2, R2, R0	;R2 = fib(n-1)
	ADD	R1, R1, #-1
	LEA	R7, #1
	BRnzp	FIB		;fib(n-2)
	ADD	R2, R2, R0	;R2 += fib(n-2)
	AND	R0, R0, 0
	ADD	R0, R0, R2	;R0 = R2
	BRnzp	RETURN

isZERO	AND	R0, R0, 0	;return 0
	BRnzp	RETURN

isONE	AND	R0, R0, 0
	ADD	R0, R0, 1	;return 1
	BRnzp	RETURN

RETURN	ADD	R6, R6, #-1	;stack pointer--
	LDR	R7, R6, #0	;restore R7
	ADD	R6, R6, #-1	;stack pointer--
	LDR	R1, R6, #0	;restore R1
	ADD	R6, R6, #-1	;stack pointer--
	LDR	R2, R6, #0	;restore R2
	RET

SAVER1	.BLKW	72
	.END